---
layout: cp
title: "Sarang: research funding for 2019 Q4"
author: Sarang Noether
date: 6 September 2019
amount: 417
milestones:
  - name: Funding is released
    funds: 100% (417 XMR)
    done: 23 September 2019
    status: finished
  - name: Work is done
    funds: 0% (0 XMR)
    done: 31 December 2019
    status: finished
payouts:
  - date: 23 September 2019
    amount: 417
---
Hello! Dr. Sarang Noether here, excited to continue full-time research, development, and analysis in privacy-focused cryptography and applications. You can read my previous monthly reports for [July](https://repo.getmonero.org/monero-project/ccs-proposals/merge_requests/77#note_6916) and [August](https://repo.getmonero.org/monero-project/ccs-proposals/merge_requests/77#note_7105) to see what I've been up to recently.

This funding request covers the period from September through December 2019. The next three months have a lot in store.
- New proving systems. Recent preprints, notably [IACR 944](https://eprint.iacr.org/2019/944) and [IACR 969](https://eprint.iacr.org/2019/969), provide general and efficient ways to prove statements in zero knowledge. In addition to ongoing work on existing constructions tailored specifically to transaction models, these more general approaches could have interesting practical applications that deserve investigation and analysis.
- Fall network upgrade. There is always plenty to do around upgrades relating to review and analysis.
- Simulation methods. Graph matching and augmentation models are finally to the point where we can run simulations to investigate the analytical effects of user behavior.
- Peer review. Papers for which I am coauthor need to undergo revision and review, which is always a lengthy process.

And there is always more to do that arises unexpectedly. Expect code review, the usual updates and changes, outreach, literature review, proof-of-concept code and testing, documentation, and more.

I work hard to provide value in my research for the value provided here. As before, this request is for the equivalent of 10415 USD monthly, my assessment of fair market compensation for an independent Ph.D. researcher in the United States. Therefore, using a 14-day EMA of 75 USD/XMR from Kraken, the request total is **417 XMR**. Further, note that this request will be paid in full as soon as it is funded, in order to reduce the effects of price fluctuations and ensure that contributed value is the value that reaches me.

Questions, comments, and feedback about this request are welcome.
